--- old/usr/src/uts/common/io/scsi/adapters/mpt_sas/mptsas_impl.c	2014-12-22 09:51:45.254304366 -0500
+++ new/usr/src/uts/common/io/scsi/adapters/mpt_sas/mptsas_impl.c	2014-12-22 09:51:45.282654757 -0500
@@ -1196,19 +1196,17 @@
 	slots->m_slot[MPTSAS_TM_SLOT(mpt)] = NULL;
 
 	/*
-	 * If we lost our task management command
-	 * we need to reset the ioc
+	 * If we lost our task management command we need to reset the ioc
+	 * but we can't do it here as it's most likely we were called from
+	 * the taskq that mptsas_restart_ioc()->mptsas_flush_hba() needs to
+	 * wait for. So set a flag for mptsas_watch().
 	 */
 	if (rval == FALSE) {
 		mptsas_log(mpt, CE_WARN, "mptsas_ioc_task_management failed "
-		    "try to reset ioc to recovery!");
-		mpt->m_softstate &= ~MPTSAS_SS_MSG_UNIT_RESET;
-		if (mptsas_restart_ioc(mpt)) {
-			mptsas_log(mpt, CE_WARN, "mptsas_restart_ioc failed");
-			rval = FAILED;
-		}
+		    "schedule reset in watch!");
+		mpt->m_softstate |= MPTSAS_SS_RESET_INWATCH;
 	}
-
+	
 	return (rval);
 }
 
